import { EventEmitter, ElementRef, TemplateRef, OnChanges, ChangeDetectorRef, OnInit, SimpleChanges } from '@angular/core';
import { SelectConfig } from './select.config';
import { ControlValueAccessor } from '@angular/forms';
export declare const SELECT_OPTIONS_ACCESSOR: any;
export declare class SelectOptionsComponent implements ControlValueAccessor, OnChanges, OnInit {
    protected cd: ChangeDetectorRef;
    protected el: ElementRef;
    data: SelectConfig[];
    value: number | null | undefined;
    searchable: boolean;
    disabled: boolean;
    styles: SelectConfig[];
    optionTpl: TemplateRef<any>;
    onChange: EventEmitter<SelectConfig>;
    needReposition: EventEmitter<Object>;
    onModelChange: Function;
    onModelTouched: Function;
    private _data;
    constructor(cd: ChangeDetectorRef, el: ElementRef);
    ngOnChanges(simpleChanges: SimpleChanges): void;
    ngOnInit(): void;
    onSelectOption(e: Event, data: SelectConfig): void;
    onSearch(e: any): void;
    writeValue(value: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: Function): void;
    private static _clone;
}
